//Copyright (c) 2018 Fraunhofer FIT

var vendor = "kuenzli";
var model = "nomodel";
var token = "notoken";

var footfact_url = "https://footfact.fit.fraunhofer.de/FootfactREST/rest/gettoken/";
var footfact_qrcode = "https://footfact.fit.fraunhofer.de/iiimages/";
var footfact_requestsize = "https://footfact.fit.fraunhofer.de/FootfactREST/rest/requestsize/";
var footfact_qrcode_notoken = "https://footfact.fit.fraunhofer.de/demoshop/qrcodes_notoken/";
var footfact_mobilebaseurl_android = "intent:#Intent;action=com.androidsrc.launchfootfact;category=android.intent.category.DEFAULT;category=android.intent.category.BROWSABLE;S.shoeCode=;S.shopUrl=;S.token=;S.browser_fallback_url=https://play.google.com/store/apps/details?id=com.footfact;end"
var footfact_mobilebaseurl_ios = "footfact://shoeCode=&shopUrl=&token=";
var footfact_requestmodelname = "https://footfact.fit.fraunhofer.de/FootfactREST/rest/requestshoemodelname/";


var ua;
var isAndroid;
var isiOS;

var imagedone = false;
var nobarcode = false;
var foundSize = false;
var suggestedSize = null;
var chosenSize = null;


$(document).ready(function () {

    suggestedSize = getUrlParameter("ffsize");

    console.debug("suggestedSize (ffsize):", suggestedSize);

    if (($.type(suggestedSize) === "string") && (suggestedSize.length > 0)) {

        suggestedSize = suggestedSize.substring(0, suggestedSize.indexOf("ffsize"));

        console.debug("suggestedSize (substr):", suggestedSize);

        //alert("suggested size |" + suggestedSize + "|");
        var pattern1 = suggestedSize + "[1234567890.]";
        var pattern2 = "[1234567890.]" + suggestedSize;
        var re1 = new RegExp(pattern1);
        var re2 = new RegExp(pattern2);

        //get all shoe sizes (if hikashop ever changes id of select tag, won't work anymore)

        console.debug("getting sized...");

        $("[id^=hikashop_product_characteristic_] option").each(function (index) {
            console.debug(" - size index:", index);
            //alert($ ( this ).text());
            if ($(this).text().includes(suggestedSize) && !foundSize) {
                if (re1.test($(this).text()) || re2.test($(this).text())) {
                    // bad match (like 37 when looking for size 7, or 4.5 whe looking for 4)
                    //alert("bad: " + $ ( this ).text());
                    console.warn(" - bad match:", $(this).text());

                }
                else {
                    chosenSize = $(this).text();
                    console.warn(" - chosenSize:", $(this).text());

                    $('[id^=hikashop_product_characteristic_]').find('option:nth-child(' + (index + 1) + ')').prop('selected', true).trigger('change');
                    foundSize = true;
                }
            }
        });
        if (!foundSize)
            alert("FootFact hat die Größe " + suggestedSize + " für Sie ermittelt, aber die Größe ist für das Modell nicht verfügbar.");

    }

    // replace image path with those from hika plugin pictures
    // this is because in this javascript file, we cannot know the hika shop runtime path of the images
    // we only get that from php and have to inject it here

    $("div.footfact.footfact_googlebadgepath").append('<img alt="Jetzt bei Google Play" src="' + footfact_googlebadgepath + '"/>');

    $("div.footfact.ff_applebadge").append('<img alt="Jetzt im Apple Store" src="' + footfact_applebadgepath + '"/>');

    $("div.footfact.ff_logoimage").append('<img src="' + footfact_logopath + '/>');

    $('div.footfact.footfact_qrdisplay').hide();

    ua = navigator.userAgent.toLowerCase();
    isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
    isiOS = ((ua.indexOf("iphone") > -1) || (ua.indexOf("ipad") > -1)) && (ua.indexOf("mozilla") > -1);

    if (isiOS) {
        console.debug("##### iOS detected.");
    } else {
        console.debug("##### not iOS");
    }

    var div = document.getElementById("ffdata");
    var productCode = div.textContent.trim();

    productCode = productCode.replace(" ", "_");

    console.debug("##### productCode:", productCode);

    var res = productCode.split("_");
    for (i = 0; i < res.length; i++) {
        var isnum = /^[0-9]+$/.test(res[i]);
        if (isnum)
            model = res[i];
    }
    console.debug("##### model:", model);

    //alert("model: " + model);

    var isnum = /^[0-9]+$/.test(model);
    if (!isnum) {
        console.warn("##### Shoecode " + productCode + " appears to be invalid");

        //hide everything
        document.getElementById("footfact").style.display = "none";
        return;
    }

    // check if server knows the shoe Modell
    var rmnurl = footfact_requestmodelname + vendor + "_" + model;

    console.debug("##### ajax get:", rmnurl);

    $.ajax({url: rmnurl}).then(function (response) {
        console.debug("##### ajax returned with:", response);

        if (!response.includes("Unbekannter")) {
            //shoe is known in database
        }
        else {
            //alert("unknown model");
            nobarcode = true;
        }
        imagedone = true;

        // continue synchronously in next function
        continueInit();
    }, function(error) {
        console.debug("##### ajax returned error:", error);

    });

});

function continueInit() {
    console.debug("##### continueInit");

    if (!imagedone || nobarcode) {
        alert("invalid or no image");
        //hide everything
        // alert: invalid code or image not available
        document.getElementById("footfact").style.display = "none";
        return;

    }

    if (/Mobi/.test(navigator.userAgent) || isAndroid || isiOS) {
        // hide desktop-specific elements
        // show mobile-specific elements
        document.getElementById("ff_mobile_link").style.display = "block";
        document.getElementById("ff_desktop_text").style.display = "none";
        document.getElementById("ff_desktop_text_column").style.display = "none";

        console.debug("##### startFootfactMobile");

        startFootfactMobile();
    }
    else {
        // show mobile-specific elements
        // hide desktop-specific elements

        document.getElementById("ff_mobile_link").style.display = "none";
        document.getElementById("ff_mobile_text").style.display = "none";
        $("#ff_mobile_link").attr('href', 'http://www.footfact.com');

        //document.getElementById("ff_text").innerHTML=footfact_desktop_text;
        console.debug("##### startFootfactDesktop");

        startFootfactDesktop();
    }


    if (foundSize && chosenSize != null) {
        //alert("FootFact hat die Größe " + chosenSize + " für Sie ausgewählt. ");
        var div = document.getElementById("footfact_popuptext_size_selected");
        var translatedMessage = div.textContent.trim();
        var message = translatedMessage.replace("$FFSIZE", chosenSize);
        alert(message);
    }

}


function startFootfactMobile() {
    if (vendor != "" && model != "" && model != "nomodel") {
        footfact_url += vendor;
        footfact_url += "_";
        footfact_url += model;
        $.ajax({url: footfact_url}).then(function (data) {
            footfact_requestsize += data;
            var mobileurl = "";

            if (isiOS) {
                mobileurl = footfact_mobilebaseurl_ios;
            }
            else {
                mobileurl = footfact_mobilebaseurl_android;
            }
            mobileurl = mobileurl.replace('shoeCode=', 'shoeCode=' + "kuenzli_" + model);
            mobileurl = mobileurl.replace('shopUrl=', 'shopUrl=' + window.location.href);
            mobileurl = mobileurl.replace('token=', 'token=' + token);
            if (isiOS) {
                //mobileurl = "http://www.footfact.com";
            }
            else {
            }
            $("#ff_mobile_link").attr('href', mobileurl);
            $("#ff_googlebadgelink").attr('href', mobileurl);
            //setTimeout(ajaxrepeat, 5000);
        });
    }

}

function startFootfactDesktop() {
    //alert("Starting FF Desktop");
    if (vendor != "" && model != "" && model != "nomodel") {
        footfact_url += vendor;
        footfact_url += "_";
        footfact_url += model;
        $.ajax({url: footfact_url}).then(function (data) {
            footfact_qrcode_notoken += model;
            footfact_qrcode_notoken += ".png";
            var el = kjua({text: (vendor + '_' + model), mSize: 10, fontcolor: '#006699', size: 125, mPosY: 50});
            $("div.footfact.footfact_qrdisplay").append('<img class="footfact_qrdisplay" src="' + el.src + '" align="center">');
            $('div.footfact.footfact_qrdisplay').show();
            footfact_requestsize += data;
            token = data;
            //setTimeout(ajaxrepeat, 5000);
        });
    }

}


// no longer in use: poll backend to get size result
//
// function ajaxrepeat() {
//     $.ajax({url: footfact_requestsize}).then(function (size) {
//
//         if (size > 0) {
//             size = size.trim();
//             //alert('Empfohlene Schuhgroesse:[' + size + ']');
//             $('.footfact_size').val(size);
//             $('.footfact_qrdisplay').hide();
//             $('.footfact_success').show();
//             return;
//         }
//         setTimeout(ajaxrepeat, 5000);
//     });
// }
//
//
// function sleep(ms) {
//     return new Promise(resolve = > setTimeout(resolve, ms)
// )
//     ;
// }


var getUrlParameter = function getUrlParameter(sParam) {
    var sPageURL = decodeURIComponent(window.location.search.substring(1)),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return sParameterName[1] === undefined ? true : sParameterName[1];
        }
    }
};
